#!/usr/local/bin/perl

# g-addgtypes.pl  version 1.0
#
#    converts the pair (filename, filepath or gopherpath)
#    to the pair (gophername, gopherpath)
#
#  Uses gopherd.conf, whose filename must be in $gopher_conf
#
# TODO: clean up the interface

sub add_gtypes {
  local($name, $path)= @_;
  local($_,$isftp);

  if (!defined(%ADD_GTYPE)) {
    local(@f);
    open(CONF,$gopherd_conf)
        || die "&add_gtype can't open $gopherd_conf: $!\n";
    while(<CONF>) {
      if (/^ext:/) {
          @f=split(/\s+/,$_); $f[1] =~ tr/[A-Z]/[a-z]/;
          $ADD_GTYPE{$f[1]}= $f[2].$f[3];
    } }
    close(CONF);
  }

  $isftp= ($path =~ /^ftp(-[a-z]+)?:/);

  if ($name =~ /\.tar\.[zZ]$/) {
    return ("9$name", ($isftp ? $path : "9$path"));
  }

  if ($name =~ /\.mbox$/) {
    return ("1$name", "m$path") unless $isftp;
  }

  if ($name =~ /\.[zZ]$/) {
    return ("9$name", $path) if $isftp;
    chop($name); chop($name);
  }

  local($ext) = ($name =~ m:(\.[^/.]+)$:);
  $ext =~ tr/[A-Z]/[a-z]/;
  $_ = $ADD_GTYPE{$ext};
  $_ = "00" unless $_;
  return (substr($_,0,1).$name, ($isftp ? $path : substr($_,1,1).$path));
}

1;
