# g-time.pl  version 1.0
#
# Handle "gopher time".
#
# UNDOCUMENTED
#
# TODO: move initialization of $gtime_now to the client routines, ie,
#       remove the damned global variable.

$gtime_now= &time2gtime(time());

sub time2gtime {
  local($t)= @_;
  local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)= localtime($t);
  $mon++;
  if    ($year >= 70) { $year += 1900; }
  elsif ($year <  20) { $year += 2000; }
  else { die "Sorry, limited to years between 1970 and 2020\n"; }
  return sprintf("%.4d%.2d%.2d%.2d%.2d",$year,$mon,$mday,$hour,$min);
}

sub gtime2text {
  local($gtime)= @_;
  local($text);
  local($yyyy)= substr($gtime,0,4);
  if ($yyyy ne "0000") {
    $text .= "$yyyy ";
  }
  local($mmdd)= substr($gtime,4,4);
  if ($mmdd ne "0000") {
    local($mm)= substr($mmdd,0,2);
    local($mmm)=substr("JanFebMarAprMayJunJulAugSepOctNovDec",($mm-1)*3,3);
    $text .= ( (substr($mmdd,2)+0). " $mmm ");
  }
  local($hhmm)= substr($gtime,8,4);
  if ($hhmm ne "0000") {
    $text .= (substr($hhmm,0,2). ":". substr($hhmm,2). " ");
  }
  chop($text);
  $text;
}

sub gtime_short_dif {
  local($gtime) = @_;
  local($yyyy)= substr($gtime,0,4);
  return $yyyy if $yyyy ne substr($gtime_now,0,4);

  if (substr($gtime,4,4) ne substr($gtime_now,4,4)) {
    $Mon= ("Jan", "Feb", "Mar", "Apr", "May", "Jun",
           "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")[substr($gtime,4,2)-1];
    return (substr($gtime,6,2)+0)." $Mon";
  }
  return (substr($gtime,8,2)+0). ":". substr($gtime,10,2);
}

sub absolute_gtime {
  local($gtime) = @_;
  if (substr($gtime,0,4)="0000") {
    substr($gtime,0,4)= substr($gtime_now,0,4);
    if (substr($gtime,4,4)="0000") {
      substr($gtime,4,4)= substr($gtime_now,4,4);
    }
  }
  $gtime;
}

1;
